unit umain;
{ Delphi 3 25.07.98
	Pascal Viewer

This is a simple Application to convert Pascal Source Texts to
Rich Text Format with Syntax Highlighting.

Main features:

Reading from file or copying from Clipboard, saving to RTF or printing.
Different font names, size, color, style for identifiers, key words, 
numbers, comments, etc.

Font styles are saved in INI file.

It was rewritten to Delphi 3 from my old program for BP for Windows 
and it must work on Delphi 2-4 ++, but I don't test it.
I've tried to translate all comments to English.
It is not very quick :-(.

All sources are included, so comments and suggestions are welcome.

Igor Zakhrebetkov <igorz@realty.elcom.ru>
}
interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls,
  Clipbrd, INIFiles;

const
     AL   =  14;
     LL   = 16384;
     TabSize = 4;
     NStrMax =30000;
     CF_RICHEDIT = 54696;
     CF_RichTextFormat = 52907;
type
     Alfa =String[AL];
     Symbol = (Divider, Ident, Number, KEYsym,Stroka, Comment);
     ModeType = (Declaration, Operator, Assembler, Comment1, Comment2,Comment3);
     Item =
     record
        W: Alfa;
        S: Symbol;
     end;
     ItemPtr = ^Item;
     StyleRec =
     record
        f: TLogFont;
        C: LongInt;
     end;
     FontRec =
     record
        Name  : String[31];
        Color : TColor;
        Size  : integer;
        Style : TfontStyles;
     end;

     pFontTable =^FontTable;
     FontTable = array [Symbol] of StyleRec;

const NORW=79;  { No of reserved words  =  .  }
      SymbolName: array[Symbol] of String[11]=
      ('Divider', 'Ident', 'Number', 'KeyWord','String', 'Comment');
      {TFontStyle = (fsBold, fsItalic, fsUnderline, fsStrikeOut);}
      FontStyleNames: array[TFontStyle] of String[11]=
      ('Bold', 'Italic', 'Underline', 'StrikeOut');
     KEY : array [1..NORW] of Item=
     (
     (W: 'ABSOLUTE';   S: KEYsym),
     (W: 'AND';        S: KEYsym),
     (W: 'ARRAY';      S: KEYsym),
     (W: 'AS';        S: KEYsym),
     (W: 'ASM';        S: KEYsym),
     (W: 'ASSEMBLER'; S: KEYsym),
     (W: 'BEGIN';      S: KEYsym ),
     (W: 'BOOLEAN';    S: KEYsym),
     (W: 'CASE';       S: KEYsym),
     (W: 'CHAR';       S: KEYsym),
     (W: 'CLASS';      S: KEYsym),
     (W: 'CONST';      S: KEYsym),
     (W: 'CONSTRUCTOR';S: KEYsym),
     (W: 'DESTRUCTOR'; S: KEYsym),
     (W: 'DIV';        S: Divider),
     (W: 'DO';         S: KEYsym),
     (W: 'DOWNTO';     S: KEYsym),
     (W: 'ELSE';       S: KEYsym),
     (W: 'END';        S: KEYsym),
     (W: 'EXCEPT';    S: KEYSym),
     (W: 'EXPORTS';    S: KEYSym),
     (W: 'EXTERNAL';   S: KEYsym),
     (W: 'FILE';       S: KEYsym),
     (W: 'FINALIZATION'; S: KeySym),
     (W: 'FINALLY';   S: KEYsym),
     (W: 'FOR';        S: KEYsym),
     (W: 'FORWARD';    S: KEYsym),
     (W: 'FUNCTION';   S: KEYsym),
     (W: 'GOTO';       S: KEYsym),
     (W: 'IF';         S: KEYsym),
     (W: 'IMPLEMENTATION'; S: KEYsym),
     (W: 'IN';         S: KEYsym),
     (W: 'INHERITED';  S: KEYSym),
     (W: 'INITIALIZATION';     S: KeySym),
     (W: 'INLINE';     S: KEYsym),
     (W: 'INTEGER';    S: KEYsym),
     (W: 'INTERFACE';  S: KEYsym),
     (W: 'INTERRUPT';  S: KEYsym),
     (W: 'IS';        S: KEYsym),
     (W: 'LABEL';      S: KEYsym),
     (W: 'LIBRARY';     S: KEYSym),
     (W: 'MOD';        S: Divider),
     (W: 'NIL';        S: KEYsym),
     (W: 'NOT';        S: KEYsym),
     (W: 'OBJECT';     S: KEYsym),
     (W: 'OF';         S: KEYsym),
     (W: 'OR';         S: KEYsym),
     (W: 'PACKED';     S: KEYsym),
     (W: 'PRIVATE';   S: KEYsym),
     (W: 'PROCEDURE';  S: KEYsym),
     (W: 'PROGRAM';    S: KEYsym),
     (W: 'PROPERTY';     S: KeySym),
     (W: 'PROTECTED,';   S: KeySym),
     (W: 'PUBLIC';       S: KeySym),
     (W: 'PUBLISHED';    S: KeySym),
     (W: 'RAISE';        S: KeySym),
     (W: 'READ';       S: Ident ),
     (W: 'READLN';     S: Ident ),
     (W: 'RECORD';     S: KEYsym),
     (W: 'REPEAT';     S: KEYsym),
     (W: 'SET';        S: KEYsym),
     (W: 'SHL';        S: Divider),
     (W: 'SHR';        S: Divider),
     (W: 'STRING';     S: KEYsym{Ident}),
     (W: 'TEXT';       S: Ident ),
     (W: 'THEN';       S: KEYsym),
     (W: 'TO';         S: KEYsym),
     (W: 'TRY';       S: KEYsym),
     (W: 'TYPE';       S: KEYsym),
     (W: 'UNIT';       S: KEYsym),
     (W: 'UNTIL';      S: KEYsym ),
     (W: 'USES';       S: KEYsym),
     (W: 'VAR';        S: KEYsym),
     (W: 'VIRTUAL';    S: KEYsym),
     (W: 'WHILE';      S: KEYsym),
     (W: 'WITH';       S: KEYsym),
     (W: 'WRITE';      S: Ident ),
     (W: 'WRITELN';    S: Ident ),
     (W: 'XOR';        S: Divider)
     );
type
     Line=packed array[1..LL] of char;
     LongString=
     record LEN: integer; STR: Line;
     end;

     TTextExtent =
     record
        W, H: Word;
     end;
type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    FilePrintItem: TMenuItem;
    FilePrintSetupItem: TMenuItem;
    FileExitItem: TMenuItem;
    EditUndoItem: TMenuItem;
    EditCutItem: TMenuItem;
    EditCopyItem: TMenuItem;
    EditPasteItem: TMenuItem;
    StatusLine: TStatusBar;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    PrintSetupDialog: TPrinterSetupDialog;
    SpeedBar: TPanel;
    SpeedButton1: TSpeedButton;  { &Open... }
    SpeedButton2: TSpeedButton;  { &Print... }
    SpeedButton3: TSpeedButton;  { P&rint Setup... }
    SpeedButton4: TSpeedButton;  { E&xit }
    SpeedButton5: TSpeedButton;  { &Undo }
    SpeedButton6: TSpeedButton;  { Cu&t }
    SpeedButton7: TSpeedButton;  { &Copy }
    SpeedButton8: TSpeedButton;  { Select All }
    RichEdit1: TRichEdit;
    FontsItems: TMenuItem;
    MainFontItem: TMenuItem;
    KeyWordItem: TMenuItem;
    CommentItem: TMenuItem;
    FontDialog1: TFontDialog;
    DividerItem: TMenuItem;
    NumberItem: TMenuItem;
    StringItem: TMenuItem;
    SpeedButton9: TSpeedButton;
    PastewithHighLight1: TMenuItem;  { &Paste }
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FileNew(Sender: TObject);
    procedure FileOpen(Sender: TObject);
    procedure FileSave(Sender: TObject);
    procedure FileSaveAs(Sender: TObject);
    procedure FilePrint(Sender: TObject);
    procedure FilePrintSetup(Sender: TObject);
    procedure FileExit(Sender: TObject);
    procedure EditUndo(Sender: TObject);
    procedure EditCut(Sender: TObject);
    procedure EditCopy(Sender: TObject);
    procedure EditPaste(Sender: TObject);
    procedure MainFontItemClick(Sender: TObject);
    procedure KeyWordItemClick(Sender: TObject);
    procedure CommentItemClick(Sender: TObject);
    procedure DividerItemClick(Sender: TObject);
    procedure NumberItemClick(Sender: TObject);
    procedure StringItemClick(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure EditPasteItemClick(Sender: TObject);
  public
    Attr: array [Symbol] of FontRec; {TTextAttributes; }
      CC,CCpr,
      PosComment, PosBefore,
      NumStr,
      pCh: integer;
      i,
      Ni: integer;              { No of spaces =     }
      Cpr, ChU,
      Ch: char;
      EndLine : Boolean;
      Si:  Symbol;               { Current word type   }
      {Sym: Symbol;}
      Mode: ModeType;
      {Wi:  WordObj;}
      Ai,
      Blank: ShortString;
      InS: LongString;
    procedure LoadFile(FileName: ShortString);
    procedure GetCH;
    procedure GetWord;
    procedure SetAttr(Si: Symbol);
    procedure SetFont(Si: Symbol);
    procedure CheckForIni;
    procedure ReadIni;
    procedure WriteIni(Si: Symbol);
    function GetPath: string;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.CheckForIni;
{ create INI file if not exists }
var
  F: TextFile;
  INIfileName: string;
  st: Symbol;
  ss: TFontStyle;

begin
  INIfileName:=GetPath + 'PASVIEW.INI';
  if not FileExists(INIfileName) then
   begin
    System.Assign(F, INIfileName);
    System.ReWrite(F);
    for st:=Divider to Comment do with Attr[st] do
    begin
      System.WriteLn(F, '[',SymbolName[st],']');
      System.WriteLn(F, 'Name=', Name);
      System.WriteLn(F, 'Color=',IntToHex(Color,6));
      System.Write(F, 'Style=');
      for ss:=fsBold to fsStrikeOut do
        if ss in Style then Write(F,FontStyleNames[ss],' ');
      System.WriteLn(F);
      System.WriteLn(F, 'Size=',Size);
    end;
(**)
    System.Close(F);
  end;
end;

procedure TMainForm.ReadIni;
var
  IniFile: TIniFile;
  INIfileName: string;
  st: Symbol;
  ss: TFontStyle;
  S: String;
begin
   INIfileName:=GetPath + 'PASVIEW.INI';
   IniFile := TIniFile.Create(INIfileName);
   for st:=Divider to Comment do with Attr[st] do
   begin
      Name  :=IniFile.ReadString (SymbolName[st], 'Name', 'Arial');
      Color :=StrToInt('$'+IniFile.ReadString(SymbolName[st], 'Color', '000000'));
      S     :=IniFile.ReadString (SymbolName[st], 'Style', '');
      Style :=[];
      for ss:=fsBold to fsStrikeOut do
        if pos(S,FontStyleNames[ss])>0 then include(Style,ss);
      Size  :=IniFile.ReadInteger(SymbolName[st], 'Size', 12);
   end;
   IniFile.Free;
end;

procedure TMainForm.WriteIni(Si: Symbol);
var
  IniFile: TIniFile;
  S,
  INIfileName: string;
  ss: TFontStyle;
begin
   INIfileName:=GetPath + 'PASVIEW.INI';
   IniFile := TIniFile.Create(INIfileName);
   with IniFile, Attr[Si] do
   begin {IntToHex HextoInt}
      WriteString (SymbolName[si], 'Name', Name);
      WriteString(SymbolName[si], 'Color', IntToHex(Color,6));
      S:='';
      for ss:=fsBold to fsStrikeOut do
       if ss in Style then S:=S+FontStyleNames[ss]+' ';
      WriteString (SymbolName[si], 'Style', S);
      WriteInteger(SymbolName[si], 'Size', Size);
   end;
   IniFile.Free;
end;

function TMainForm.GetPath: string;
begin
  Result := ExtractFilePath(ParamStr(0));
end;

procedure TMainForm.SetAttr(Si: Symbol);
begin
   with RichEdit1, Attr[Si] do
   begin
      SelAttributes.Name   := Attr[Si].Name ;
      SelAttributes.Color  := Attr[Si].Color;
      SelAttributes.Size   := Attr[Si].Size ;
      SelAttributes.Style  := Attr[Si].Style;
    {  SelAttributes.  := ;    }
   end;
end;

procedure TMainForm.SetFont(Si: Symbol);
begin
   with FontDialog1, Attr[Si] do
   begin
      Font.Name  := Name;
      Font.Style := Style;
      Font.Color := Color;
      Font.Size  := Size;
      if FontDialog1.Execute then
      begin
         Name  := font.Name;
         Style := Font.Style;
         Color := Font.Color;
         Size  := Font.Size;
         WriteINI(Si);
      end;
   end;
end;

 procedure GetSTR (var f: TextFile; var S: LongString; L: integer);
       {  }
  var i, j: integer; Ch: char;
  begin  S.LEN:=0; i:=0;
     while (not eoln(f)) and (i<L) do with S do
     begin Read(f, Ch);
        if Ch=#9 then {TAB -  }
        begin  j:=((i+TabSize) div TabSize)* TabSize;
           while (i<j) and (i<L) do
           begin INC(i); STR[i]:=' ';
           end;
        end else
        begin INC(i); STR[i]:=Ch;
        end
     end;
     S.LEN:=i;
     if eoln(f) then
     begin  Readln(f);  with S do for j:=i+1 to L do STR[j]:=' ';
     end
  end;

 procedure TMainForm.GetCH;
  begin Cpr:=Ch;
     with InS do
     begin     if pCh>=LEN then
        begin  Ch:=' '; ChU:=' ';
           EndLine:=TRUE; Exit   { Endline mark }
        end else
        begin
           INC(pCh);
           if pCh>LEN then Ch:=' ' else Ch:=STR[pCh];
           ChU:=UpCase(Ch);
        end;     { Upper Case of Letters =      }
     end;{ WITH }
  end { GETCH };

 procedure TMainForm.GetWord;
       {  }
  var
       i,j,k: integer;
       BIT: Boolean;
       A:    Alfa;
  begin { GetWord }
     Ni:=0; Ai:='';
     while (Ch =' ')and not EndLine do
     begin
        GetCH;
        INC(Ni);
     end;
     if Mode=Comment1 then
     begin Si:=Comment;
        while (Ch<>'}')and not EndLine do
        begin  Ai:=Ai+Ch;
           GetCH;
        end;
        if Ch='}' then
        begin  Ai:=Ai+Ch;
           GetCH; Mode:=Operator;
        end else Mode:=Comment1;
     end else
     if Mode=Comment2 then
     begin Si:=Comment;
        repeat Ai:=Ai+Ch;
           GetCH;
        until (Cpr='*')and(Ch=')') or EndLine;
        if Ch=')' then
        begin  Ai:=Ai+Ch;
           GetCH; Mode:=Operator;
        end else Mode:=Comment2;
     end else
     if ChU in ['A'..'Z',''..'',''..''] then
     begin  Si:=Ident;
        repeat Ai:=Ai+Ch;
           GetCH;
           BIT:=ChU in ['0'..'9','_'];
        until not (BIT or (ChU in ['A'..'Z',''..'',''..'']));
        if (not BIT) and (Length(Ai)<=AL) then
        begin (* Search in Key table =    *)
           for i:=0 to Length(Ai) do A[i]:=UpCase(Ai[i]);
           i:=1; j:=NORW;
           repeat k:=(i+j) div 2;
              if A<=KEY[k].W then j:=k-1;
              if A>=KEY[k].W then i:=k+1;
           until i>j;
           if i-1>j then
           begin
              Si:=KEY[k].S; {BIT:=TRUE;}
           end
        end;
     end else
     if Ch in ['0'..'9'] then
     begin  Si:=Number;
        repeat Ai:=Ai+Ch;
           GetCH;
        until not (ChU in ['0'..'9','.','E']);
     end else
     if Ch ='$' then  { Hex number }
     begin  Si:=Number;
        repeat Ai:=Ai+Ch;
           GetCH;
        until not (ChU in ['0'..'9','A'..'F']);
     end else
     if Ch ='^' then  { Ctrl Char or Pointer ?}
     begin Ai:=Ai+Ch;
        GetCH;
        if Ch in ['A'..'Z'] then
        begin
           Ai:=Ai+Ch; GetCH;
          if Ch in ['A'..'Z'] then Si:=Ident else Si:=Stroka;
        end else Si:=Divider;
     end else
     if Ch ='#' then  { Char number }
     begin  Si:=Stroka; Bit:=false;
        repeat Ai:=Ai+Ch;
           GetCH;
           if (Ch='$') and Bit then
           begin Ai:=Ai+Ch; GetCH;
           end;
           Bit :=true;
        until not (ChU in ['0'..'9','A'..'F']);
     end else
     if Ch='''' then
     begin Si:=Stroka;
        repeat Ai:=Ai+Ch;
           GetCH;
        until (Ch='''') or EndLine;
        if Ch='''' then
        begin  Ai:=Ai+Ch;
           GetCH;
        end
     end else
     if Ch='{' then
     begin Si:=Comment;
        repeat Ai:=Ai+Ch;
           GetCH;
        until (Ch='}') or EndLine;
        if Ch='}' then
        begin  Ai:=Ai+Ch;
           GetCH;
        end else Mode:=Comment1;
     end else
     begin  Si:=Divider;
        Ai:=Ch; GetCH;
        {if (Ch=^M) or (Ch=^J) then}
        if (Cpr='(')and(Ch='*') then
        begin Si:=Comment;
           Ai:=Ai+Ch; GetCH;
           if not EndLine then
           repeat Ai:=Ai+Ch;
              GetCH;
           until (Cpr='*')and(Ch=')') or EndLine;
           if Ch=')' then
           begin  Ai:=Ai+Ch;
              GetCH;Mode:=Operator;
           end else Mode:=Comment2;
        end else
        if (Cpr='/')and(Ch='/') then
        begin Si:=Comment;
           Ai:=Ai+Ch; GetCH;
           if not EndLine then
           repeat Ai:=Ai+Ch;
              GetCH;
           until (Ch=^M)or(Ch=^J)or(EndLine);
           if Ch<' ' then
           begin
              GetCH;
           end;
           Mode:=Operator;
        end;
     end
  end { GetWord };


procedure TMainForm.LoadFile(FileName: ShortString{var Vvod: TextFile});
      {   - Reading of text file }
 var
      vvod: TextFile;

 begin
    {   }
    System.Assign(vvod,FileName);
    {$I-}
    System.Reset(vvod);
    {$I+}
    if IOResult<>0 then                  {File Exists?   ?}
    begin                                {-:   }
       ShowMessage('Can''t open file '+FileName);
       Exit;
    end;
    RichEdit1.Clear;        { ? }
    {     }
    NumStr:=0;
    Mode:= Declaration;
    while (not eof(vvod) and(NumStr<Nstrmax)) do
    begin
       GetSTR(vvod,InS,LL); INC(NumStr);
       {New(pWL[NumStr],Init);}
       pCh:=0; Ch:=' '; EndLine:=FALSE;
       while (not EndLine) do
       begin
          GetWord;
          with RichEdit1 do
          begin
             SetAttr(Divider);
             SelText:=copy(blank,1,Ni);
             SetAttr(Si);
             SelText:=Ai;
          end;
          {New(pW,Init(Ni,Si,Ai)); pWL[NumStr]^.Add(pW);}
       end;
       with RichEdit1 do
       begin
          SetAttr(Divider);
          SelText:=^M^J;
       end;
    end;
    System.Close(vvod);
    (* 
    Scroller^.SetRange(10,NumStr);     { }
    InvalidateRect(hWindow,nil,TRUE)   { }
    *)
 end;  {LoadFile}

procedure TMainForm.FormCreate(Sender: TObject);
var s: Symbol;
begin
  Application.OnHint := ShowHint;
  {
  for s := Divider to Comment do Attr[s] := TFont.Create;
  }
  with Attr[Divider] do
  begin
     Name  := 'Arial Cyr';
     Color := clBlack;
     Size  := 10;
     Style := [];
  end;
  for s := succ(Divider) to Comment do with Attr[s] do
  begin
     Attr[s] := Attr[Divider];
     case s of
     Divider: begin Name:='Courier New Cyr'; end;
     Ident: begin  end;
     Number: begin  Color :=clBlue; end;
     KEYsym: begin  Style :=[fsBold]; Name:='Times New Roman Cyr'; end;
     Stroka: begin  Color :=clGreen;  Name:='Courier New Cyr'; end;
     Comment: begin Color :=clRed; Style :=[fsItalic]; end;
     end { case};
  end;
  FillChar(Blank,SizeOf(Blank),' ');
  Blank[0] :=chr(SizeOf(Blank)-1);
  CheckForINI; { create INI file if not exists }
  ReadINI;
  SaveDialog.FileName:='NONAME.RTF';
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusLine.SimpleText := Application.Hint;
end;

procedure TMainForm.FileNew(Sender: TObject);
begin
  { Add code to create a new file }
   RichEdit1.Clear;
   SaveDialog.FileName:='NONAME.RTF';
end;

procedure TMainForm.FileOpen(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    { Add code to open OpenDialog.FileName }
    MainForm.Caption := OpenDialog.FileName;
    LoadFile(OpenDialog.FileName);
    StatusLine.SimpleText := OpenDialog.FileName;
    SaveDialog.Filename:=ChangeFileExt(OpenDialog.Filename, '.RTF');
  end;
end;

procedure TMainForm.FileSave(Sender: TObject);
begin
   { Add code to save current file under current name }
  if SaveDialog.Execute then
  begin
    { Add code to save current file under SaveDialog.FileName }
    RichEdit1.Lines.SaveToFile(SaveDialog.FileName);
  end;
end;

procedure TMainForm.FileSaveAs(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    { Add code to save current file under SaveDialog.FileName }
    RichEdit1.Lines.SaveToFile(SaveDialog.FileName);
  end;
end;

procedure TMainForm.FilePrint(Sender: TObject);
begin
  if PrintDialog.Execute then
  begin
    { Add code to print current file }
    RichEdit1.Print(MainForm.Caption);
  end;
end;

procedure TMainForm.FilePrintSetup(Sender: TObject);
begin
  PrintSetupDialog.Execute;
end;

procedure TMainForm.FileExit(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditUndo(Sender: TObject);
begin
  { Add code to perform Edit Undo }
  RichEdit1.Perform(EM_UNDO, 0, 0);
end;

procedure TMainForm.EditCut(Sender: TObject);
begin
  { Add code to perform Edit Cut }
   RichEdit1.CutToClipboard;
end;

procedure TMainForm.EditCopy(Sender: TObject);
begin
  { Add code to perform Edit Copy }
   RichEdit1.CopyToClipboard;
end;

procedure TMainForm.EditPaste(Sender: TObject);
{var Buf: pChar;}
begin
  { If not RTF then Show as Pascal }
  if ClipBoard.HasFormat(CF_RichTextFormat)
   then RichEdit1.PasteFromClipboard
  else begin
     Ins.Len := ClipBoard.GetTextBuf(@Ins.STR,SizeOf(Ins.Str));
    {     }
    NumStr:=0;
    Mode:= Declaration;
    pCh:=0; Ch:=' '; EndLine:=FALSE;
    while (not EndLine) do
    begin
       GetWord;
       with RichEdit1 do
       if (Si=Divider) and ((Ai=^J)or(Ai=^M)) then
       begin if Ch<' ' then GetCh;
          SetAttr(Divider);
          SelText:=^M^J;
       end else
       begin
          SetAttr(Divider);
          SelText:=copy(blank,1,Ni);
          SetAttr(Si);
          SelText:=Ai;
       end;
    end {while};
  end { not CF_RTF};
end;

procedure TMainForm.MainFontItemClick(Sender: TObject);
begin
   SetFont(Ident);
end;

procedure TMainForm.KeyWordItemClick(Sender: TObject);
begin
   SetFont(KeySym);
end;

procedure TMainForm.CommentItemClick(Sender: TObject);
begin
   SetFont(Comment);
end;

procedure TMainForm.DividerItemClick(Sender: TObject);
begin
   SetFont(Divider);
end;

procedure TMainForm.NumberItemClick(Sender: TObject);
begin
   SetFont(Number);
end;

procedure TMainForm.StringItemClick(Sender: TObject);
begin
   SetFont(Stroka);
end;


procedure TMainForm.SpeedButton9Click(Sender: TObject);
begin
   { Select All}
  with RichEdit1 do
  begin
     SelStart:=0;
     SelLength:=Length(Lines.Text);
  end;
end;

procedure TMainForm.EditPasteItemClick(Sender: TObject);
begin
    RichEdit1.PasteFromClipboard;
end;

end.

